<template>
	<view class="todo-page">
		<step-title :stepPage="stepsPage" :stepText="stepsText"></step-title>
		<view class="allview">
			<view class="card" v-if="stepsPageList === 0">
				<u--form labelWidth="auto" :model="dataModel" ref="wForm" class="demo-ruleForm">
					<view style="position: relative;">
						<view style="position: absolute;left: -10px;color: #3d4b70;top: -3px;">*</view>
					</view>

					<view style="font-size: 15px; font-weight: bold;color: #3d4b70;margin-bottom: 10px;">基本信息填写</view>
					<u-form-item label="年度：" prop="YEAR">
						<u--input v-model="dataModel.YEAR" disabled Color="#ffffff" placeholder="请填写年度" border="none" inputAlign="right" fontSize="14px">
						</u--input>
					</u-form-item>
					<!-- <u-form-item label="辨识与评估内容:">
					</u-form-item>
					<u--textarea v-model="dataModel.CONTENTS" placeholder="请输入内容" autoHeight></u--textarea> -->
					<u-form-item label="辨识开始时间:" @click="handleChangeRecitify('start')">
						<u--input v-model="dataModel.START_DATE" placeholder="请选择时间" disabled Color="#ffffff" inputAlign="right" fontSize="14px" border="none">
						</u--input>
						<!-- <u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
						</u-icon> -->
					</u-form-item>
					<u-form-item label="辨识结束时间:" @click="handleChangeRecitify('end')">
						<u--input v-model="dataModel.END_DATE" placeholder="请选择时间" disabled Color="#ffffff" inputAlign="right" fontSize="14px" border="none">
						</u--input>
						<!-- <u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
						</u-icon> -->
					</u-form-item>
					<u-form-item label="辨识要求:" @click="handleChangeStep('','demand')">
						<u--input v-model="dataModel.Nav_Require.NAME" placeholder="请选择辨识要求" disabled disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
						</u--input>
						<u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
						</u-icon>
					</u-form-item>
					<u--textarea v-model="dataModel.RequireName" disabled autoHeight></u--textarea>
					<view class="upload-title">附件：</view>
					<full-upload v-model="dataModel.Nav_Files" :isShowBtn='true' :listProp='listPropUpload' :listPropVal='listPropValUpload'></full-upload>

				</u--form>
			</view>
			<view style="padding: 10px 16px;" v-if="stepsPageList === 0" class="bottom-button">
				<u-button type="primary" :loading="stepLoad" @click="stepAdd" color="#3d4b70">下一步</u-button>
			</view>
			<view class="card" v-if="stepsPageList === 1">
				<u--form labelWidth="auto" :model="dataModel" ref="wForm" class="sub-form">


					<view style="position: relative;">

						<view style="position: absolute;left: -10px;color: #3d4b70;top: -3px;">*</view>
					</view>

					<view style="font-size: 15px; font-weight: bold;color: #3d4b70;margin-bottom: 10px;margin-top: 20px;">辨识内容</view>
					<view v-for="(item,index) in dataModel.Nav_Details" :key="index" style="border-bottom: #ceccca 1px solid;margin-bottom: 10px;padding-bottom: 10px;">
						<u-form-item prop="Nav_Contents">

							<view style="display: flex;flex-direction: row;justify-content: space-between;align-items: center;flex: 1;">
								<view @click="handleChangeStep(index,'Area')" style="flex: 1;">
									{{index+1+'.辨识区域：'+item.Nav_Area.NAME}}
								</view>
								<view class="action" style="display: flex;flex-direction: row;align-items: center;justify-content: space-around;">
									<u-icon @click="handleDelRowBefore(index)" name="trash" color="#ff4d4f" size="21" style="margin-right: 20px;"></u-icon>
									<u-icon name="arrow-up" size="12" v-if="item.showPack" @click="handlePack(index)"></u-icon>
									<u-icon name="arrow-down" size="12" v-if="!item.showPack" @click="handlePack(index)"></u-icon>
								</view>
							</view>
						</u-form-item>
						<view v-if="item.showPack==true">
							<u-form-item label="生产单元：" @click="handleChangeUnit(index,'MinType')" border-bottom>
								<u--input v-model="item.MineType" disabled disabledColor="#ffffff" placeholder="请选择生产单元" border="none" inputAlign="right" fontSize="14px">
								</u--input>
								<u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
								</u-icon>
							</u-form-item>
							<!-- <u-form-item label="风险名称" prop="CHECKSTANDARD" border-bottom>
								<u--input v-model="item.RISK_NAME" placeholder="请填写风险名称" disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
							</u-form-item> -->
							<u-form-item label="风险名称" prop="CHECKSTANDARD" @click="handleChangeStep(index,'RiskName')" border-bottom>
								<u--input v-model="item.Nav_RiskName.NAME" placeholder="请填写风险名称" suffixIcon="arrow-down" suffixIconStyle="font-size: 12px" disabledColor="#ffffff" inputAlign="right" fontSize="14px"
									border="none">
								</u--input>
							</u-form-item>
							<u-form-item label="风险描述" prop="HIDDEN_DESCRIPTION">
							</u-form-item>
							<u--textarea v-model="item.RISK_DESCRIPTION"  placeholder="请填写风险描述" autoHeight maxlength="-1"></u--textarea>
							<u-form-item label="风险类别" prop="HIDDEN_LEVEL" @click="handleChangeStep(index,'Category')" border-bottom>
								<u--input v-model="item.Nav_Type.NAME" placeholder="请选择风险类别" disabled suffixIcon="arrow-down" suffixIconStyle="font-size: 12px" disabledColor="#ffffff" inputAlign="right" fontSize="14px"
									border="none">
								</u--input>
							</u-form-item>
							<u-form-item label="辨识层级" prop="HIDDEN_PLACE" border-bottom>
								<u--input v-model="item.DEPARTMENT_TYPE" placeholder="请填写辨识层级" disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
							</u-form-item>
							<u-form-item label="辨识部门" prop="HIDDEN_PLACE" border-bottom>
								<u--input v-model="item.IDENTIFY_DEPARTMENT" placeholder="请填写辨识部门" disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
							</u-form-item>
							<u-form-item label="辨识岗位" prop="HIDDEN_PLACE" border-bottom>
								<u--input v-model="item.IDENTIFY_POST" placeholder="请填写辨识岗位" disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
							</u-form-item>
							<u-form-item label="管控措施" prop="HIDDEN_PLACE" >
								<!-- <u--input v-model="item.MEASURE" placeholder="请填写管控措施" disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input> -->
							</u-form-item>
							<u--textarea v-model="item.MEASURE"  placeholder="请填写管控措施" autoHeight maxlength="-1"></u--textarea>
							<u-form-item label="应急处置" prop="HIDDEN_PLACE" border-bottom>
							</u-form-item>
							<u--textarea v-model="item.EMERGENCY"  placeholder="请填写应急处置" autoHeight maxlength="-1"></u--textarea>
							<u-form-item label="是否有效" prop="HIDDEN_PLACE" @click="handleChangeUnit(index,'ENABLE_STATUS')" border-bottom>
								<u--input v-model="item.ENABLE_STATUS" placeholder="请选择是否有效" disabled disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
								<u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
								</u-icon>
							</u-form-item>
							<!-- <u-form-item label="新增标识" prop="HIDDEN_PLACE" @click="handleChangeUnit(index,'MARK')">
								<u--input v-model="item.MARK" placeholder="请选择新增标识" disabled disabledColor="#ffffff" inputAlign="right" fontSize="14px" border="none">
								</u--input>
								<u-icon style="margin-left: 4px;" slot="right" name="arrow-down" size="12">
								</u-icon>
							</u-form-item> -->
						</view>
					</view>
					<u-button text="新增检查区域" type="primary" @click="handleNewCheckContent"></u-button>
				</u--form>
			</view>
			<view style="padding: 10px 16px;display: flex;flex-direction: row;" v-if="stepsPageList === 1" class="bottom-button">
				<u-button type="primary" @click="stepReduce" color="#3d4b70" :plain="true" style="margin-right: 5px;">上一步</u-button>
				<u-button type="primary" @click="submit" color="#3d4b70" style="margin-left: 5px;">提交</u-button>
			</view>
			<u-picker :show="showPopupUnit" :columns="UnitLists" @confirm="confirmUnit" @cancel="cancelUnit" :defaultIndex="UnitDefaultIndex"></u-picker>
			<u-modal :show="showDelModalIndex >= 0" @confirm="confirmDel" @cancel="cacelDel" :showCancelButton="true" title="确认删除？"></u-modal>
			<u-datetime-picker :show="showPopupRecitifyDate" v-model="dateRecitifyTime" mode="date" @confirm="confirmRecitifyDate" @cancel="cancelRecitifyDate"></u-datetime-picker>
			<query-selector :show="showPopupStep" :total="curTotalStep" :lists="stepLists" :defaultValue="currentOperateStep.NAME" @close="handleClosePopupStep" @search="handleSearchStep" @select="handleSelectedStep" />
		</view>
	</view>
</template>

<script>
	import {
		extendFilterGroup,
		extendGroupRule,
		extendInclude,
		extendOrder,
		extendRule,
		extendIgnoreDataRule,
		guid,
		initFilter,
		initFilterGroup,
		handleOriginalArray
	} from '../../../../utils/common'
	import {
		FMProductionUnit,
		SKEffective,
		SKMarkEnum,
		CheckPeriods,
		CheckLevels,
		MineTypeIndex,
		MineTypeName
	} from '../../../../utils/enums.js'
	import {
		EvaIdentifyResGet,
		IdentifyResFullUpdate,
		getUserLists,
		GetSKRequestInfo,
		GetRiskAreaInfo,
		GetRiskTypeInfo,
		GetRiskNameInfo
	} from '../../../../services/apply/subPages/SK/SKServices.js'
	import {
		getRequest,
	} from '../../../../services/apply/FOServices/FOServices';
	import stepTitle from '@/components/custom/step-title.vue'
	import swipeActionItem from '../../../../uni_modules/uview-ui/libs/config/props/swipeActionItem';
	export default {
		components: {
			stepTitle,
		},
		data() {
			return {
				showDelModalIndex: undefined,
				showPopupDate: false,
				showPopupRecitifyDate: false,
				listPropUpload: ['NOTIFY_ID'],
				listPropValUpload: [],
				ORG_ID: uni.getStorageSync('orgId'),
				currentOperateStep: {},
				showPopupStep: false,
				stepLists: [],
				curTotalStep: 0,
				showPopupUnit: false,
				stepLoad: true,
				UnitLists: [],
				UnitDefaultIndex: [0],
				dataModel: {
					YEAR: '',
					START_DATE: '',
					END_DATE: '',
					Nav_Require: {
						NAME: ''
					},
					RequireName: '',
					IDENTIFY_EVALUATION_PLAN_ID:null,
					IDENTIFY_ID:null,
					Nav_Files: [],
					Nav_Details: [{
						showPack: false,
						MineType: '',
						Nav_Area: {
							NAME: ''
						},
						RISK_NAME: '',
						Nav_RiskName: {
							NAME: ''
						},
						RISK_DESCRIPTION: '',
						Nav_Type: {
							NAME: ''
						},
						DEPARTMENT_TYPE:'',
						IDENTIFY_DEPARTMENT:'',
						IDENTIFY_POST:'',
						MEASURE: '',
						EMERGENCY: '',
						ENABLE_STATUS: '',
						MARK: '',
					}]
				},
				model: {
					ORG_ID: '',
					YEAR: '',
					START_DATE: '',
					END_DATE: '',
					Nav_Require: {
						NAME: ''
					},
					RequireName: '',
					IDENTIFY_EVALUATION_PLAN_ID:null,
					IDENTIFY_ID:null,
					Nav_Files: [],
					Nav_Details: [{
						MineType: '',
						Nav_Area: {
							NAME: ''
						},
						RISK_NAME: '',
						Nav_RiskName: {
							NAME: ''
						},
						RISK_DESCRIPTION: '',
						Nav_Type: {
							NAME: ''
						},
						DEPARTMENT_TYPE:'',
						IDENTIFY_DEPARTMENT:'',
						IDENTIFY_POST:'',
						MEASURE: '',
						EMERGENCY: '',
						ENABLE_STATUS: '',
					}]

				},
				dateRecitifyTime: uni.$u.timeFormat(new Date(), 'yyyy-mm-dd'),
				stepsText: ['发起', '审批', '归档'],
				stepsPage: 0,
				stepsPageList: 0,
				TaskID: '',
				nowName: '',
				nowIndex: 0,

			}
		},
		onLoad(option) {
			this.TaskID = option.taskID ? option.taskID : '';
			this.ID = option.ID ? option.ID : '';
			this.loadData()
		},
		methods: {
			loadData() {
				// const json = {}
				const orgId = uni.getStorageSync('orgId')
				const json = initFilter(orgId, "", "")
				extendRule(json, 'ID', 1, this.ID);
				extendInclude(json, 'Nav_Require');
				extendInclude(json, 'Nav_Files.Nav_ImgFile');
				extendInclude(json, 'Nav_Details');
				extendInclude(json, 'Nav_Details.Nav_Area');
				extendInclude(json, 'Nav_Details.Nav_Type');
				extendInclude(json, 'Nav_Details.Nav_RiskName');
				extendInclude(json, 'Nav_Details.Nav_DetailMeasures');
				extendIgnoreDataRule(json)
				// extendRule(json, 'TASK_ID', 1, this.TaskID);
				EvaIdentifyResGet(json).then(res => {
					this.dataModel = res;
					this.stepsPage = res.STATUS == 0 ? 0 : res.STATUS == 20 ? 1 : 2
					this.dataModel.START_DATE = uni.$u.timeFormat(res.START_DATE, 'yyyy-mm-dd')
					this.dataModel.END_DATE = uni.$u.timeFormat(res.END_DATE, 'yyyy-mm-dd')
					this.dataModel.RequireName = res.Nav_Require ? res.Nav_Require.NAME : {
							NAME: ''
						},
					this.dataModel.Nav_Require = res.Nav_Require ? res.Nav_Require : {
							NAME: ''
						},
					this.dataModel.Nav_Details.map(item => {
						item['showPack'] = false
						item.ENABLE_STATUS = item.ENABLE_STATUS == 0 ? '有效' : '无效'
						item.MARK = item.MARK == 0 ? '自动带出' : item.MARK == 10 ? '新增' : '修改'
						item.MineType = MineTypeName[item.MineType]
						item.Nav_RiskName = item.Nav_RiskName? item.Nav_RiskName: {
							NAME: ''}
					})
					this.stepLoad = false

				})
			},
			handlePack(index) {
				this.dataModel.Nav_Details[index].showPack = this.dataModel.Nav_Details[index].showPack == false ? true : false
				this.dataModel.Nav_Details = [...this.dataModel.Nav_Details]

			},
			cancelUnit() {
				this.showPopupUnit = false
			},
			handleChangeUnit(index, name) {
				this.nowIndex = [index, name]
				if (name == 'MinType') {
					this.UnitLists = [FMProductionUnit]
				} else if (this.nowIndex[1] == 'ENABLE_STATUS') {
					this.UnitLists = [SKEffective]
				} else {
					this.UnitLists = [SKMarkEnum]
				}
				this.showPopupUnit = true
			},
			confirmUnit(e) {
				if (this.nowIndex[1] == 'MinType') {
					this.dataModel.Nav_Details[this.nowIndex[0]].MineType = e.value[0]
				} else if (this.nowIndex[1] == 'ENABLE_STATUS') {
					this.dataModel.Nav_Details[this.nowIndex[0]].ENABLE_STATUS = e.value[0]
				} else {
					this.dataModel.Nav_Details[this.nowIndex[0]].MARK = e.value[0]
				}
				this.showPopupUnit = false
			},
			stepAdd() {
				if(!this.dataModel.YEAR){
					uni.showToast({
						title: '年度不能为空',
						icon: 'none'
					})
					return
				}
				if(!this.dataModel.START_DATE){
					uni.showToast({
						title: '辨识开始时间不能为空',
						icon: 'none'
					})
					return
				}
				if(!this.dataModel.END_DATE){
					uni.showToast({
						title: '辨识结束时间不能为空',
						icon: 'none'
					})
					return
				}
				if(!this.dataModel.Nav_Require.NAME){
					uni.showToast({
						title: '辨识要求不能为空',
						icon: 'none'
					})
					return
				}
				
				this.stepsPageList = this.stepsPageList + 1
			},
			stepReduce() {
				this.stepsPageList = this.stepsPageList - 1
			},
			handleNewCheckContent() {
				this.dataModel.Nav_Details.push({
					showPack: false,
					MineType: '',
					Nav_Area: {
						NAME: ''
					},
					ORG_ID: this.ORG_ID,
					RISK_NAME: '',
					Nav_RiskName:{
						NAME: ''
					},
					RISK_DESCRIPTION: '',
					Nav_Type: {
						NAME: ''
					},
					DEPARTMENT_TYPE:'',
					IDENTIFY_DEPARTMENT:'',
					IDENTIFY_POST:'',
					MEASURE: '',
					EMERGENCY: '',
					ENABLE_STATUS: '有效',
				})

				this.dataModel.Nav_Details = [...this.dataModel.Nav_Details]
			},
			handleDelRowBefore(index) {
				this.showDelModalIndex = index
				this.nowIndex = index


			},
			confirmDel() {
				this.dataModel.Nav_Details.splice(this.nowIndex, 1)
				this.showDelModalIndex = undefined

			},
			cacelDel() {
				this.showDelModalIndex = undefined
			},
			cancelRecitifyDate() {
				this.showPopupRecitifyDate = false
			},
			handleChangeRecitify(name) {
				this.nowName = name
				this.showPopupRecitifyDate = true
			},
			confirmRecitifyDate(e) {
				if (this.nowName == 'start') {
					this.dataModel.START_DATE = uni.$u.timeFormat(e.value,
						'yyyy-mm-dd')

				} else {
					this.dataModel.END_DATE = uni.$u.timeFormat(e.value,
						'yyyy-mm-dd')
				}
				this.dateRecitifyTime = uni.$u.timeFormat(e.value,
					'yyyy-mm-dd')

				this.showPopupRecitifyDate = false
			},
			handleChangeStep(index, name) {
				this.currentOperateStep = {}
				this.showPopupStep = true
				this.nowIndex = [index, name]
				this.handleSearchStep('init')
			},
			handleClosePopupStep() {
				this.showPopupStep = false
				// this.showPopupCertificate = false
			},
			handleSearchStep(val, pageIndex) {
				let requestInfo = this.nowIndex[1] == 'demand' ? GetSKRequestInfo : this.nowIndex[1] == 'Area' ? GetRiskAreaInfo  : this.nowIndex[1] == 'RiskName' ? GetRiskNameInfo:GetRiskTypeInfo
				const orgId = uni.getStorageSync('orgId')
				const json = initFilter(orgId, "", "",0, pageIndex ?? 1)
				json.Limit = 20
				if (pageIndex) {
					json.Start = (pageIndex - 1) * json.Limit;
				}
				if (val !== 'init') {
					const tempGroup = initFilterGroup(false);
					extendGroupRule(tempGroup, 'NAME', 9, val)
					extendFilterGroup(json, tempGroup);
				}
				
				requestInfo(json).then(res => {
					// if (res.IsSuccessful) {
					this.stepLists = (res.Data || res).map(i => {
						return {
							...i,
							id: i.ID,
							name: i.NAME,
						}
					})
					this.curTotalStep = res.TotalCount
					// }
				})


			},
			handleSelectedStep(val) {
				if (this.nowIndex[1] == 'demand') {
					this.dataModel.Nav_Require.NAME = val.NAME
					this.dataModel.REQUIRE_ID = val.ID
					this.dataModel.RequireName = val.NAME
				} else if (this.nowIndex[1] == 'Area') {
					this.dataModel.Nav_Details[this.nowIndex[0]].Nav_Area.NAME = val.NAME
					this.dataModel.Nav_Details[this.nowIndex[0]].AREA_ID = val.ID
				} else if (this.nowIndex[1] == 'RiskName') {
					this.dataModel.Nav_Details[this.nowIndex[0]].Nav_RiskName.NAME = val.NAME
					this.dataModel.Nav_Details[this.nowIndex[0]].RISK_NAME_ID = val.ID
				} 
				else {
					this.dataModel.Nav_Details[this.nowIndex[0]].Nav_Type.NAME = val.NAME
					this.dataModel.Nav_Details[this.nowIndex[0]].TYPE_ID = val.ID
				}
				this.showPopupStep = false

			},

			submit() {
				let i=1
				for (let item of this.dataModel.Nav_Details) {
					if (!item.MineType) {
						uni.showToast({
							title: '顺序'+i+'生产单元不能为空',
							icon: 'none'
						})
						return
					}
					if (!item.Nav_Area.NAME) {
						uni.showToast({
							title: '顺序'+i+'辨识区域不能为空',
							icon: 'none'
						})
						return
					}
					// if (!item.RISK_NAME) {
					// 	uni.showToast({
					// 		title: '风险名称不能为空',
					// 		icon: 'none'
					// 	})
					// 	return
					// }
					if (!item.Nav_RiskName.NAME) {
						uni.showToast({
							title: '顺序'+i+'风险名称不能为空',
							icon: 'none'
						})
						return
					}
					if (!item.RISK_DESCRIPTION) {
						uni.showToast({
							title: '顺序'+i+'风险描述不能为空',
							icon: 'none'
						})
						return
					}
					if (!item.Nav_Type.NAME) {
						uni.showToast({
							title: '顺序'+i+'风险类别不能为空',
							icon: 'none'
						})
						return
					}
					i++
				}

				// this.model = this.dataModel

				this.model.ORG_ID = this.ORG_ID
				let arr = []

				this.dataModel.Nav_Details.map(item => {
					arr.push({
						MineType: MineTypeIndex[item.MineType],
						AREA_ID: item.AREA_ID,
						RISK_NAME: item.RISK_NAME,
						RISK_NAME_ID: item.RISK_NAME_ID,
						RISK_DESCRIPTION: item.RISK_DESCRIPTION,
						TYPE_ID: item.TYPE_ID,
						DEPARTMENT_TYPE:item.DEPARTMENT_TYPE,
						IDENTIFY_DEPARTMENT:item.IDENTIFY_DEPARTMENT,
						IDENTIFY_POST:item.IDENTIFY_POST,
						MEASURE: item.MEASURE,
						EMERGENCY: item.EMERGENCY,
						ENABLE_STATUS: !item.ENABLE_STATUS ? 0 : item.ENABLE_STATUS == '有效' ? 0 : 10,
					})
				})
				this.model = {
					ORG_ID: this.ORG_ID,
					YEAR: this.dataModel.YEAR,
					START_DATE: this.dataModel.START_DATE,
					END_DATE: this.dataModel.END_DATE,
					REQUIRE_ID: this.dataModel.REQUIRE_ID,
					RequireName: this.dataModel.RequireName,
					IDENTIFY_EVALUATION_PLAN_ID:this.dataModel.IDENTIFY_EVALUATION_PLAN_ID,
					IDENTIFY_ID:this.dataModel.IDENTIFY_ID,
					Nav_Files: this.dataModel.Nav_Files,
					Nav_Details: arr
				}
				this.model.ID = this.ID
				this.model.TaskID = this.TaskID
				this.model.PUBLISH = "SaveAndNotify";
				IdentifyResFullUpdate(this.model).then(res => {
					if (res) {
						uni.$showMsgFunc('操作成功!', () => {
							uni.navigateBack()
						}, 'success', 1000)
					}
				})


			}

		}



	}
</script>

<style scoped>
	@import url("../../../../style/css/newTemplate.css");
</style>